summaryrefslogtreecommitdiff
path: root/helpers/lh_chroot_linux-image
diff options
context:
space:
mode:
Diffstat (limited to 'helpers/lh_chroot_linux-image')
-rwxr-xr-xhelpers/lh_chroot_linux-image115
1 files changed, 115 insertions, 0 deletions
diff --git a/helpers/lh_chroot_linux-image b/helpers/lh_chroot_linux-image
new file mode 100755
index 0000000..660ae40
--- /dev/null
+++ b/helpers/lh_chroot_linux-image
@@ -0,0 +1,115 @@
+#!/bin/sh
+
+# lh_chroot_linux-image(1) - manage /etc/kernel-img.conf
+# Copyright (C) 2006-2007 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Source common functions
+for FUNCTION in /usr/share/live-helper/functions/*.sh
+do
+ . ${FUNCTION}
+done
+
+# Set static variables
+DESCRIPTION="manage /etc/kernel-img.conf"
+HELP=""
+USAGE="${PROGRAM} {install|remove} [--force]"
+
+Arguments "${@}"
+
+Echo_debug "Init ${PROGRAM}"
+
+# Reading configuration files
+Read_conffile config/common
+Read_conffile config/bootstrap
+Read_conffile config/chroot
+Read_conffile config/binary
+Read_conffile config/source
+Set_defaults
+
+Breakpoint "chroot_linux-image: Init"
+
+# Requiring stage file
+Require_stagefile .stage/bootstrap
+
+case "${1}" in
+ install)
+ # Checking stage file
+ Check_stagefile .stage/chroot_linux-image
+
+ # Checking lock file
+ Check_lockfile .lock
+
+ # Creating lock file
+ Create_lockfile .lock
+
+ if [ -f chroot/etc/kernel-img.conf ]
+ then
+ # Saving kernel-img.conf
+ cp chroot/etc/kernel-img.conf chroot/etc/kernel-img.conf.old
+ fi
+
+ # Configuring kernel-img.conf
+cat >> chroot/etc/kernel-img.conf << EOF
+do_bootloader = No
+do_initrd = Yes
+warn_initrd = No
+EOF
+
+ if [ "${LIVE_LINUX_PACKAGES}" != "none" ]
+ then
+ for FLAVOUR in ${LIVE_LINUX_FLAVOURS}
+ do
+ for PACKAGE in ${LIVE_LINUX_PACKAGES}
+ do
+ PACKAGES="${PACKAGES} ${PACKAGE}-${FLAVOUR}"
+ done
+ done
+ fi
+
+ PACKAGES="${PACKAGES} ${LH_INITRAMFS}"
+
+ # Installing linux-image, modules and ${LH_INITRAMFS}
+ case "${LH_APT}" in
+ apt|apt-get)
+ Chroot "apt-get install --yes ${PACKAGES}"
+ ;;
+
+ aptitude)
+ Chroot "aptitude install --assume-yes ${PACKAGES}"
+ ;;
+ esac
+
+ # Creating stage file
+ Create_stagefile .stage/chroot_linux-image
+ ;;
+
+ remove)
+ # Checking lock file
+ Check_lockfile .lock
+
+ # Creating lock file
+ Create_lockfile .lock
+
+ if [ -f chroot/etc/kernel-img.conf.old ]
+ then
+ # Restoring kernel-img.conf file
+ mv chroot/etc/kernel-img.conf.old chroot/etc/kernel-img.conf
+ else
+ # Removing kernel-img.conf file
+ rm -f chroot/etc/kernel-img.conf
+ fi
+
+ # Removing stage file
+ rm -f .stage/chroot_linux-image
+ ;;
+
+ *)
+ Usage
+ ;;
+esac